#!/bin/bash
#ENCODING: UTF-8
#Created by Jordi Hortal v1.2
AUTO=false
if [ $# -eq 0 ]; then
	read -p "Start as: master or slave? " SCRIPT
elif [ $# -eq 1 ]; then
	SCRIPT="$1"
elif [ $# -eq 3 ]; then
	SCRIPT="$1"
	MASTER="$2"
	SLAVE="$3"
	AUTO=true
else
	echo "$(tput setaf 1)Incorrect parameters$(tput sgr 0)"
	exit 1
fi

echo "Creating configuration as $SCRIPT"
if [ "$SCRIPT" = "master" ]; then
	#read -p "ip of the PC or master: " MESTRE
	#MESTRE=192.168.1.100
	MESTRE=$(ifconfig wlan0 | grep 'inet addr:' | grep -v '127.0.0.1' | cut -d: -f2 | awk '{ print $1}')
	if [ "$MESTRE" = "" ]; then
		MESTRE=$(ifconfig wlan0 | grep 'inet:' | grep -v '127.0.0.1' | cut -d: -f2 | awk '{ print $1}')
		if [ "$MESTRE" = "" ]; then
		echo "$(tput setaf 1)ERR: No internet conection detected$(tput sgr 0)"
		exit 1
		fi
	fi
	#depenent del pc pot ser inet o inet addr
	
	echo "ip of the PC or master: $MESTRE"
	export ROS_HOSTNAME=$MESTRE
	export ROS_MASTER_URI=http://$MESTRE:11311
	sleep 1
	
	roscore&
	sleep 2
	#rosparam set joy_node/dev "/dev/input/js1"
	#Si dona error en el joynode llavors has de mirar en quin js# s'ha posat
	rosrun joy joy_node&
	rosrun joy2twist joy2twist.py&
	sleep 1
	
	read -p "$(tput setaf 4)Do you want to connect to a robot remotely (yes/no): $(tput sgr 0) " SSH
	ERR=true
	if [ $SSH = "s" ] || [ $SSH = "si" ] || [ $SSH = "SI" ] || [ $SSH = "S" ] || [ $SSH = "yes" ] || [ $SSH = "y" ]; then
		echo "$(tput setaf 4)Select remote direction"
		echo "1) BigBot"
		echo "2) Jordi acer"
		echo "3) arlab Asus"
		echo "4) new...$(tput sgr 0)"
		while [ $ERR != "false" ]
		do
		read NUM
		case $NUM in
			1)	USER="mobilerobot"
				HOST="192.168.1.101"
				ERR=false
				;;
			2)	USER="jordi"
				HOST="192.168.1.146"
				ERR=false
				;;
			3)	USER="arlab"
				HOST="192.168.1.100"
				ERR=false
				;;
			4)	read -p "Introduce IP: " HOST
				read -p "Introduce name of the user: " USER
				ERR=false
				;;
			*)	echo "$(tput setaf 1)ERR: wrong select$(tput sgr 0)"
		esac
		done
		
		USER_HOST="$USER@$HOST"
		gnome-terminal -e ./inici_remot.exp\ $USER_HOST\ $MESTRE\ $HOST\ 0
		sleep 1
		
		rosrun image_view image_view image:=/axis/image_raw _image_transport:=compressed &
		sleep 2
		rosrun image_view image_view image:=/camera/rgb/image_color _image_transport:=compressed &
		sleep 10
		
		read -p "Vols iniciar stream_d'audio? (s/n)" AUDIO
		
		if [ $AUDIO = "s" ]; then
			./stream_audio.sh\ $MESTRE\ $ESCLAU\ $USER_HOST 
		elif [ $AUDIO = "n" ];then
			exit 0
		else
			echo "$(tput setaf 1)ERR: Wrong type"
			echo "Pots iniciar manualment l'stream amb sh stream_audio.sh$(tput sgr 0)"
			exit 1
		fi

	else 
		exit 1
	fi

elif [ "$SCRIPT" = "slave" ]; then
	if [ $AUTO = "true" ]; then
		MESTRE="$MASTER"
		ESCLAU="$SLAVE"
	else
		read -p "ip of the PC or master: " MESTRE
		read -p "ip of the robot or slave: " ESCLAU
	fi

	export ROS_HOSTNAME=$ESCLAU
	export ROS_MASTER_URI=http://$MESTRE:11311
	gnome-terminal --title "kinect" -x bash -c "roslaunch openni_launch openni.launch "&
	sleep 2
	
	echo "executa rosrun project bigbot"
	rosrun projectbigbot base_controller &
	sleep 3
	export ROS_NAMESPACE=axis
	rosrun axis_camera axis.py _hostname:=axis-00408cac2fb4.local _password:=ferran &
	
	echo "executa rosrun axis_camera"
	sleep 3
	avconv -f alsa -i hw:0,0 -acodec libmp3lame -ab 32k -ar 14500 -re -f rtp rtp://234.5.0.5:1234
	echo "enviant audio per rtp:234.5.0.5:1234"
	sleep 2
	exit 0 
else
	echo "$(tput setaf 1)ERR: Wrong type$(tput sgr 0)"
	exit 1
fi
echo "$(tput setaf 2)Configurate as $SCRIPT. End program. $(tput sgr 0)"
#printf "es com echo pero sense fer un \n"
#roscore
#rosnode kill audio_play
#rosrun audio_capture audio_capture
#rosnode kill audio_capture
#rosrun audio_play audio_play
#gnome-terminal --title "rosrun axis_camera" -x bash -c "rosrun axis_camera axis.py _hostname:=axis-00408cac2fb4.local _password:=ferran "&
exit 0
