#include "ros/ros.h"
#include "std_msgs/String.h"
#include "std_msgs/Int8.h"
#include "std_msgs/Int16.h"
#include "std_msgs/Float64.h"
#include "std_msgs/Float32.h"

#define SLOW 1000
#define FAST 500

/**
 *  !FUNCIONS DELS SUBSCRIPTORS!
 */
void tempsCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("temps: [%d]", msg2->data);
}

void ErrorCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Error: [%d]", msg2->data);
}
//Velocitats
void Vel_FLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Velocitat Roda davant-esquerra: [%d]", msg2->data);
}
void Vel_FRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Velocitat Roda davant-dreta: [%d]", msg2->data);
}

void Vel_BLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Velocitat Roda darrera-esquerra: [%d]", msg2->data);
}

void Vel_BRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Velocitat Roda darrera-dreta: [%d]", msg2->data);
}
//Senyals de control
void Cont_FLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Control Roda davant-esquerra: [%d]", msg2->data);
}
void Cont_FRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Control Roda davant-dreta: [%d]", msg2->data);
}

void Cont_BLCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Control Roda darrera-esquerra: [%d]", msg2->data);
}

void Cont_BRCallback(const std_msgs::Int8::ConstPtr& msg2)
{
  ROS_INFO("Control Roda darrera-dreta: [%d]", msg2->data);
}
//Intensitats
void Int_FLCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  ROS_INFO("Intensitat Roda davant-esquerra: [%f]", msg2->data);
}

void Int_FRCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  ROS_INFO("Intensitat Roda davant-dreta: [%f]", msg2->data);
}

void Int_BLCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  ROS_INFO("Intensitat Roda darrera-esquerra: [%f]", msg2->data);
}

void Int_BRCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  ROS_INFO("Intensitat Roda darrera-esquerra: [%f]", msg2->data);
}

//Nivell de bateria
void BatCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  ROS_INFO("Bateria: [%f]V", msg2->data);
}

void VccCallback(const std_msgs::Float64::ConstPtr& msg2)
{
  ROS_INFO("Vcc: [%f]V", msg2->data);
}

//Posicio
void PosXCallback(const std_msgs::Float32::ConstPtr& msg2)
{
  ROS_INFO("PosX: [%f]m", msg2->data);
}

void PosYCallback(const std_msgs::Float32::ConstPtr& msg2)
{
  ROS_INFO("PosY: [%f]m", msg2->data);
}
void ThetaCallback(const std_msgs::Float32::ConstPtr& msg2)
{
  ROS_INFO("Theta: [%f]º", msg2->data);
}

msg2->data

int main(int argc, char **argv)
{
  ros::init(argc, argv, "listener");

  ros::NodeHandle n;

  ros::Subscriber sub2 = n.subscribe("Temps", SLOW, tempsCallback);
  ros::Subscriber sub3 = n.subscribe("Error", SLOW, ErrorCallback);
  ros::Subscriber sub4 = n.subscribe("Velocitat_FL", FAST, Vel_FLCallback);
  ros::Subscriber sub5 = n.subscribe("Velocitat_FR", FAST, Vel_FRCallback);
  ros::Subscriber sub6 = n.subscribe("Velocitat_BL", FAST, Vel_BLCallback);
  ros::Subscriber sub7 = n.subscribe("Velocitat_BR", FAST, Vel_BRCallback);
  ros::Subscriber sub8 = n.subscribe("Intensitat_FL", SLOW, Int_FLCallback);
  ros::Subscriber sub9 = n.subscribe("Intensitat_FR", SLOW, Int_FRCallback);
  ros::Subscriber sub10 = n.subscribe("Intensitat_BL", SLOW, Int_BLCallback);
  ros::Subscriber sub11 = n.subscribe("Intensitat_BR", SLOW, Int_BRCallback);
  ros::Subscriber sub12 = n.subscribe("Bateria", SLOW, BatCallback);
  ros::Subscriber sub13 = n.subscribe("Vcc", SLOW, VccCallback);
  ros::Subscriber sub14 = n.subscribe("Control_FL", SLOW, Cont_FLCallback);
  ros::Subscriber sub15 = n.subscribe("Control_FR", SLOW, Cont_FRCallback);
  ros::Subscriber sub16 = n.subscribe("Control_BL", SLOW, Cont_BLCallback);
  ros::Subscriber sub17 = n.subscribe("Control_BR", SLOW, Cont_BRCallback);
  ros::Subscriber sub18 = n.subscribe("Pos_X", FAST, PosXCallback);
  ros::Subscriber sub19 = n.subscribe("Pos_Y", FAST, PosYCallback);
  ros::Subscriber sub20 = n.subscribe("Theta", FAST, ThetaCallback);
  
  ros::spin();

  return 0;
}
